#include <iostream>
#include <string>
#include <string.h>
#include <map>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <math.h>
#include <time.h>

using namespace std;

int TOINTDEC=0;

void randomize(){
	srand (time(NULL));
}
int irandom(int max, int min=0){
	if (max == 0 || max < min) return 0;
	return min + (rand() % (int)(max - min + 1));
}
int to_int(char const *s)
{
	TOINTDEC=0;
     if ( s == NULL || *s == '\0' )
        throw std::invalid_argument("null or empty string argument");

     bool negate = (s[0] == '-');
     if ( *s == '+' || *s == '-' ) 
         ++s;

     if ( *s == '\0')
        throw std::invalid_argument("sign character only.");

     int result = 0;
     while(*s)
     {
          if ( *s >= '0' && *s <= '9' )
          {
              result = result * 10  - (*s - '0');  //assume negative number
          }
          else {
			  if (*s == '.'){
				  ++s;
				  TOINTDEC = to_int(s);
			  }
              return negate ? result : -result;//throw std::invalid_argument("invalid input string");
		  }
          ++s;
     }
     return negate ? result : -result; //-result is positive!
} 

/*
int borderthing(int a, int b){
	if (a<0||b<0) return 0;
	return (a+b)/2;
}
int borderthing(int a, int b, int c){
	if (a<0||b<0||c<0) return 0;
	return (a+b+c)/3;
}
*/
int borderthing(int a, int b, int c, int d){
	if (a<0||b<0||c<0||d<0) return 0;
	return (a+b+c+d)/4;
}
